
/*	Author:		Amal Alsuwaidan
	Supervisor: 	Dr. Ryan Leduc
	

	Project submitted to the Department of Computing and Software of McMaster University
	in partial fulfilment of the requirements for the degree of M.A.Sc in Software Engineering
	2012 - 2015
*/
#pragma once

#include <QDialog>
#include "ui_DefaultFTDlg.h"
#include "DesFlatProject.h"
#include "DesEvent.h"
#include "DesProject.h"
#include <QList>


namespace DESpot
{
	class DefaultFTDlg: public QDialog, private Ui::DefaultFTDlg
	{
	 	Q_OBJECT

		public:
			DefaultFTDlg(DesProject& currentProject, QList<QString>& nonFaultSet , QList<QString>& DFaultSet, QWidget* parent = 0);
			virtual ~DefaultFTDlg(void);


		//Overridables
		protected:
			virtual void accept();
		private slots:
			void onAddFaults();
			void onRemoveFaults();
			bool onValidateFaults();


		//Implementation methods
		private:
			void listProjectEvents();

		private:
			DesProject& m_currentProject;
			QList<QString>& m_nonFaultSet;
			QList<QString>& m_DFaultSet;
			bool valid = false;
			bool modified = false;

	};

} //end of namespace DESpot
