/*	Author:		Amal Alsuwaidan
	Supervisor: 	Dr. Ryan Leduc
	

	Project submitted to the Department of Computing and Software of McMaster University
	in partial fulfilment of the requirements for the degree of M.A.Sc in Software Engineering
	2012 - 2015	
*/

#pragma once
#include "DefaultFTAlgo.h"

namespace DESpot
{	
	class NFaultsAlgo : public  DefaultFTAlgo
	{
	public:
		NFaultsAlgo(const DesProject& currentProject, QList<QString>& faultSet ,int N , QMultiMap<int,QString>& faultSets);
		~NFaultsAlgo();
		bool runAlgo();
		void constructGNF();
		void addGNF();
		bool verifyFTCtrl();
		bool isNFaultsControllable() const;
	protected:
		Des* GNFDes;
		int m_N;
		QMultiMap<int, QString>& m_faultSets;
	private:
		bool m_isNFaultsControllable;
	};
}
